/*
 * This file was generated by qdbusxml2cpp version 0.7
 * Command line was: qdbusxml2cpp -l Oscl::Qt::DBus::BlueZ::Mesh::Management1::Server -i server.h -p proxy dbus.xml
 *
 * qdbusxml2cpp is Copyright (C) 2015 The Qt Company Ltd.
 *
 * This is an auto-generated file.
 * Do not edit! All changes made to it will be lost.
 */

#ifndef PROXY_H_1600720131
#define PROXY_H_1600720131

#include <QtCore/QObject>
#include <QtCore/QByteArray>
#include <QtCore/QList>
#include <QtCore/QMap>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QVariant>
#include <QtDBus/QtDBus>
#include "server.h"

/*
 * Proxy class for interface org.bluez.mesh.Management1
 */
class OrgBluezMeshManagement1Interface: public QDBusAbstractInterface
{
    Q_OBJECT
public:
    static inline const char *staticInterfaceName()
    { return "org.bluez.mesh.Management1"; }

public:
    OrgBluezMeshManagement1Interface(const QString &service, const QString &path, const QDBusConnection &connection, QObject *parent = 0);

    ~OrgBluezMeshManagement1Interface();

public Q_SLOTS: // METHODS
    inline QDBusPendingReply<> AddNode(const QByteArray &uuid, const QVariantMap &options)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(uuid) << QVariant::fromValue(options);
        return asyncCallWithArgumentList(QLatin1String("AddNode"), argumentList);
    }

    inline QDBusPendingReply<> CreateAppKey(ushort net_index, ushort app_index)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(net_index) << QVariant::fromValue(app_index);
        return asyncCallWithArgumentList(QLatin1String("CreateAppKey"), argumentList);
    }

    inline QDBusPendingReply<> CreateSubnet(ushort net_index)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(net_index);
        return asyncCallWithArgumentList(QLatin1String("CreateSubnet"), argumentList);
    }

    inline QDBusPendingReply<> DeleteAppKey(ushort app_index)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(app_index);
        return asyncCallWithArgumentList(QLatin1String("DeleteAppKey"), argumentList);
    }

    inline QDBusPendingReply<> DeleteRemoteNode(ushort primary, uchar count)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(primary) << QVariant::fromValue(count);
        return asyncCallWithArgumentList(QLatin1String("DeleteRemoteNode"), argumentList);
    }

    inline QDBusPendingReply<> DeleteSubnet(ushort net_index)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(net_index);
        return asyncCallWithArgumentList(QLatin1String("DeleteSubnet"), argumentList);
    }

    inline QDBusPendingReply<> ImportAppKey(ushort net_index, ushort app_index, const QByteArray &app_key)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(net_index) << QVariant::fromValue(app_index) << QVariant::fromValue(app_key);
        return asyncCallWithArgumentList(QLatin1String("ImportAppKey"), argumentList);
    }

    inline QDBusPendingReply<> ImportRemoteNode(ushort primary, uchar count, const QByteArray &device_key)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(primary) << QVariant::fromValue(count) << QVariant::fromValue(device_key);
        return asyncCallWithArgumentList(QLatin1String("ImportRemoteNode"), argumentList);
    }

    inline QDBusPendingReply<> ImportSubnet(ushort net_index, const QByteArray &net_key)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(net_index) << QVariant::fromValue(net_key);
        return asyncCallWithArgumentList(QLatin1String("ImportSubnet"), argumentList);
    }

    inline QDBusPendingReply<> SetKeyPhase(ushort net_index, uchar phase)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(net_index) << QVariant::fromValue(phase);
        return asyncCallWithArgumentList(QLatin1String("SetKeyPhase"), argumentList);
    }

    inline QDBusPendingReply<> UnprovisionedScan(const QVariantMap &options)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(options);
        return asyncCallWithArgumentList(QLatin1String("UnprovisionedScan"), argumentList);
    }

    inline QDBusPendingReply<> UnprovisionedScanCancel()
    {
        QList<QVariant> argumentList;
        return asyncCallWithArgumentList(QLatin1String("UnprovisionedScanCancel"), argumentList);
    }

    inline QDBusPendingReply<> UpdateAppKey(ushort app_index)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(app_index);
        return asyncCallWithArgumentList(QLatin1String("UpdateAppKey"), argumentList);
    }

    inline QDBusPendingReply<> UpdateSubnet(ushort net_index)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(net_index);
        return asyncCallWithArgumentList(QLatin1String("UpdateSubnet"), argumentList);
    }

Q_SIGNALS: // SIGNALS
};

namespace org {
  namespace bluez {
    namespace mesh {
      typedef ::OrgBluezMeshManagement1Interface Management1;
    }
  }
}
#endif
